In order to efficiently and accurately address your issue or feature request, please read through the template below and answer all relevant questions. Your additional work here is greatly appreciated and will help us respond as quickly as possible. Please delete any sections or questions below that do not pertain to this request.

For general support or usage questions, please use the [Auth0 Community](https://community.auth0.com/) or [Auth0 Support](https://support.auth0.com).

### Description

Description of the bug or feature request and why it's a problem. Consider including:

- The use case or overall problem you're trying to solve
- Information about when the problem started

### Prerequisites

- [ ] I have checked the [README documentation](https://github.com/auth0/angular-jwt/blob/master/README.md).
- [ ] I have checked the [Auth0 Community](https://community.auth0.com/) for related posts.
- [ ] I have checked for related or duplicate [Issues](https://github.com/auth0/angular-jwt/issues) and [PRs](https://github.com/auth0/angular-jwt/pulls).
- [ ] I have read the [Auth0 Code of Conduct](https://github.com/auth0/open-source-template/blob/master/CODE-OF-CONDUCT.md).

### Environment

Please provide the following:

- Version of `angular-jwt` used:
- Version of Angular used:
- Browser version tested:
- Additional modules/plugins/add-ons that might be affecting your instance:

### Reproduction

Detail the steps taken to reproduce this error and note if this issue can be reproduced consistently or if it is intermittent.

Please include:

- Code sample to reproduce the issue
- Log files (redact/remove sensitive information)
- Application settings (redact/remove sensitive information)
- Screenshots, if helpful
